'use strict';
var codes, names, descriptions, params, megaTable;

function removeLine(e) {
e.parentElement.parentElement.outerHTML = '';
}

function tableForm() {
document.querySelector('#resultat').innerHTML = megaTable;
}

function inputVal(e) {
	let val_number = Number(e.value);
	e.value = val_number;
}

function inputValue(e) {
	e.setAttribute('value', e.value);
}

	//=================================
document.addEventListener("DOMContentLoaded", function(event) {
	document.querySelector('.inputFile').onchange = function() {
		Papa.parse(this.files[0], {
			complete: function(results) {
			dataCalc(results.data);
		}
		});
	};
});
	//=================================
function dataCalc(data) {
	let descN = data[0].indexOf('Short description'),
		featN = data[0].indexOf('Features'),
		nameN = data[0].indexOf('Product name'),
		codeN = data[0].indexOf('Product code'),
		//
		descArr = [],
		featArr = [],
		//
		newSetParams = [],
		commonParams = [];
	//=================================
		if( descN == -1 || featN == -1 ) {
			alert('Программа не обнаружила столбцы "Short description" и/или "Features". Загрузите нужный файл');
			return;
		}
		if( nameN != -1 ) {
			names = [];
			for( let i = 1; i < data.length - 1; i++ ) {
				names.push(data[i][nameN]);
			}
		}
		if( codeN != -1 ) {
			codes = [];
			for( let i = 1; i < data.length - 1; i++ ) {
				codes.push(data[i][codeN]);
			}
		}
	//=================================
	document.querySelector('#info').innerHTML = '<p style="color:green;text-align:center;font-size:16px;padding-bottom:5px">Количество товаров: ' + (data.length - 2) + '</p>';
	for( let i = 1; i < data.length - 1; i++ ) {
		descArr.push(data[i][descN]);
		featArr.push(data[i][featN]);
	}
	
	descriptions = descArr;
	params = featArr;
	//=================================
	for( let i = 0; i < featArr.length; i++ ) {
		let options = featArr[i].split('; ');
		for( let o = 0; o < options.length; o++ ) {
			let s = options[o];
			let paramName = '';
				if( s.includes('(') ) {
					if( s.includes('))') ) if( s.split('))')[1] !== undefined ) paramName = (s.split('))')[1].split(':')[0]).trim();
					else paramName = (s.split(') ')[1].split(':')[0]).trim();
			}
			else {
				paramName = (s.split(':')[0]).trim();
			}
			newSetParams.push(paramName);
		}
	}
	//=================================
	function uniq(a) {
		return Array.from(new Set(a));
	}
	newSetParams = uniq(newSetParams);
	//=================================
	for( let i = 0; i < newSetParams.length; i++ ) {
		let n = 0;
		for( let o = 0; o < featArr.length; o++ ) {
			if(featArr[o].includes(newSetParams[i])) n += 1;
		}
		commonParams.push(n);
	}
	//=================================
	megaTable = '<hr /><table id="table" border="1" cellpadding="1" cellspacing="1"><tbody><tr>' + 
					'<td>Позиция</td>' +
					'<td>Название характеристики</td>' +
					'<td>Повторений</td>' +
					'<td>Убрать</td></tr>';
					
	for( let i = 0; i < newSetParams.length; i++ ) {
		megaTable += '<tr><td><input oninput="inputValue(this)" type="number" min="1" max="1000" value="' + (i+1) + '"></td>' +
					 '<td>' + newSetParams[i] + '</td>' +
					 '<td class="center">' + commonParams[i] + '</td>' +
					 '<td class="center"><span title="Удалить строку" onclick="removeLine(this)" class="close">❌</span></td></tr>';
	}
	
	megaTable += '</tbody></table><hr /><p style="text-align:center"><button onclick="tableForm()">Сгенерировать таблицу снова</button><button style="margin-left:30px" onclick="shortDescForm()">Сформировать краткое описание для товаров</button></p><hr />';
	tableForm();
	//
	for( let i = 0; i < document.querySelectorAll('td').length; i++) {
		let e = document.querySelectorAll('td')[i];
		if(e.innerHTML === '') e.parentElement.outerHTML = '';
	}
	for( let i = 0; i < document.querySelectorAll('input').length; i++) {
		document.querySelectorAll('input')[i].setAttribute('value', i);
	}
	//=================================
	document.querySelector('#variant').style.display = '';
}

function shortDescForm() {
	let q = document.querySelector('#table').children[0].children.length - 1,
		values = Array(q),
		shortsDescs = [],
		//
		selectBox = document.querySelector('select'),
		currentIndex = selectBox.selectedIndex,
		selected = selectBox[currentIndex].value;

	for( let i = 1; i < q+1; i++ ) {
		let s = document.querySelector('#table').children[0].children[i].innerHTML,
			n = parseInt(s.split('value="')[1]),
			val = s.split('<td>')[2].split('</td>')[0];
		values[n - 1] = val;
	}
	for( let i = 0; i < params.length; i++ ) {
		shortsDescs[i] = '<ul>';
		//
			for(let o = 0; o < values.length; o++) {
				if( params[i].includes(values[o]) ) {
					let s = params[i].split(values[o])[1];
					//
					if( s.split('[')[1] === '' ) s = '[' + s.split('[[')[1];
					else s = s.split('[')[1];
					//
					if( s.includes('];') ) s = s.split('];')[0];
					else s = s.substring(0, s.length - 1);
					//
					shortsDescs[i] += '<li>' + values[o] + ': ' + s + '</li>';
				}
			}
		//
		shortsDescs[i] += '</ul>';
		//
		let hr = '';
		if( descriptions[i] !== '') hr = '<hr />';
		console.log(descriptions[i]);
		//
		if( selected == 2 ) shortsDescs[i] += hr + descriptions[i];
		else if( selected == 3 ) shortsDescs[i] = descriptions[i] + hr + shortsDescs[i];
	}
	let finish = "";
	for( let i = 0; i < shortsDescs.length; i++ ) {
		let n = '\n'
		if(i == shortsDescs.length - 1) n = '';
		finish += shortsDescs[i] + n;
	}
	if( finish.includes('///') ) finish = finish.replace(/\/\/\//g,' | ');
	
	document.querySelector('#info').innerHTML = '<p style="color:green;text-align:center;font-size:16px;padding-bottom:5px">Столбец с краткими описаниями сформирован</p>'
	document.querySelector('#variant').innerHTML = '';
	document.querySelector('#resultat').innerHTML = '<textarea style="width:100%;min-height:500px">' + finish +
													'</textarea><p style="text-align:center;color:green">Ctrl+a (выделить всё), ' +
													'затем скопировать и заменить столбец в таблице</p>';
	see_the_result();
	
}


function see_the_result() {
	let descs = document.querySelector('#resultat').children[0].textContent.split('\n'),
	oldInner = document.querySelector('#resultat').innerHTML,
	additional,
	table,
	code = '""',
	name = '""',
	upTr = '<tr>'
	//
	if(codes != undefined) {
		upTr += '<td>Product code</td>';
		code = '"<td>" + codes[i] + "</td>"';
	}
	if(names != undefined) {
		upTr += '<td>Product name</td>';
		name = '"<td>" + names[i] + "</td>"';
	}
	//
	upTr += '<td>Short description</td></tr>';
	additional = '<table border="1" cellpadding="1" cellspacing="1" style=""><tbody>' + upTr;
	for( let i = 0; i < descs.length; i++ ) {
		additional += '<tr>' + eval(code) + eval(name) + '<td>' + descs[i] + '</td></tr>';
	}
	additional += '</tbody></table>';
	
	document.querySelector('#resultat').innerHTML = oldInner + '<hr /><button style="display:block;margin:0 auto" onclick="showOther(this)">Просмотр в виде html</button><div style="display:none">' + additional + '</div>';
}

function showOther(e) {
	e.nextSibling.style.display = '';
	e.outerHTML = '';
}